Skip to content

Overview

  • Version: 2.0.0
  • Servers: https://store.xsolla.com/api
  • Contact Us by Email
  • Contact URL: https://xsolla.com/
  • Required TLS version: 1.2

Shop Builder API provides a third-party solution for implementing the server side for your store interface. Use the endpoints to manage in-game items, in-game currencies, cart, player inventory, promotions, game library, etc.

Download OpenAPI description
Languages
Servers
Mock server
https://xsolla.redocly.app/_mock/api/shop-builder/
https://store.xsolla.com/api/
Operations

Personalized catalog

This API allows to specify rules for user attributes. If the user meets all conditions for a concrete rule, personalized items will be shown.

For personalized promotions see Promotions section.

To pass attributes before a purchase, you can use Xsolla Login API or pass them into user.attributes property while generating token using Pay Station API.

Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations

Catalog

This API allows getting any kind of sellable items or specific item.

Operations

Get sellable item by SKUClient-side

Request

Gets a sellable item by SKU for building a catalog.

Note

This endpoint, accessible without authorization, returns generic data. However, authorization enriches the response with user-specific details for a personalized result, such as available user limits and promotions.
Security
XsollaLoginUserJWT
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the name of the project.

Example: 59080
skustringrequired

Item SKU.

Example: electric_shield
Query
promo_codestring[ 1 .. 128 ] characters

Unique case sensitive code. Contains letters and numbers.

Example: promo_code=WINTER2021
show_inactive_time_limited_itemsinteger

Shows time-limited items that are not available to the user. The validity period of such items has not started or has already expired.

Default 0
Example: show_inactive_time_limited_items=1
additional_fields[]Array of strings

The list of additional fields. These fields will be in the response if you send them in your request.

Items Enum"media_list""order""long_description""custom_attributes""item_order_in_group"
curl -i -X GET \
  'https://xsolla.redocly.app/_mock/api/shop-builder/v2/project/59080/items/sku/electric_shield?promo_code=WINTER2021&show_inactive_time_limited_items=1&additional_fields%5B%5D=media_list' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

The sellable item was successfully received.

Bodyapplication/json
item_idinteger

Internal unique item ID that is provided upon item creation.

Example: 259774
skustring

Unique item ID. The SKU may contain only lowercase and uppercase Latin alphanumeric characters, periods, dashes, and underscores.

Example: "electric_shield"
namestring

Item name.

Example: "Electric shield"
groupsArray of objects(items_client_groups_response)

Groups the item belongs to.

Default []
Example: [{"external_id":"exclusive","name":"Exclusive"}]
attributesArray of objects(Virtual-Items-Currency_client-attributes)

List of attributes and their values corresponding to the item. Can be used for catalog filtering.

Default []
Example: {"value":{"external_id":"genre","name":"Жанр","values":[{"external_id":"genre_e3364991f92e751689a68b96598a5a5a84010b85","value":"Casual"},{"external_id":"genre_eba07bfd0f982940773cba3744d97264dd58acd7","value":"Strategy"},{"external_id":"genre_b8d0c6d8f0524c2b2d79ebb93aa3cd0e8b5199a8","value":"Mobile"}]}}
typestring

Type of item: virtual_good/virtual_currency/bundle/game_key/physical_good.

Enum"virtual_good""virtual_currency""bundle""game_key""physical_good"
Example: "virtual_good"
descriptionstring

Item description.

Example: "Electric shield"
image_urlstring

Image URL.

Example: "https://cdn3.xsolla.com/img/misc/images/d2d6b1b517e6a7f3765c3bb5a3cfb87d.png"
is_freeboolean(value-is_free)

If true, the item is free.

Default false
Example: false
priceobject

Item prices.

virtual_pricesArray of objects

Virtual prices.

can_be_boughtboolean

If true, the user can buy an item.

Example: true
promotionsArray of objects(Catalog_item_promotions)

Applied promotions for specific items in the cart. The array is returned in the following cases:

  • A discount promotion is configured for a specific item.

  • A promo code with the Discount on selected items setting is applied.

If no item-level promotions are applied, an empty array is returned.

virtual_item_typestring

Type of virtual item.

Enum ValueDescription
consumable

An item that disappears from the inventory after use (e.g., ammo).

non_consumable

An item that stays in the inventory for an unlimited period of time.

non_renewing_subscription

Time-limited item that can represent access to services or content for a limited period of time.

Example: "non-consumable"
limitsobject or null(Catalog_item_limits)

Item limits.

custom_attributesobject(json)(item-custom-attributes-response)

A JSON object containing item attributes and values.

vp_rewardsArray of objects(client-item-value-point-reward)

Value point item reward.

Response
application/json
{ "item_id": 259774, "sku": "com.xsolla.electric_shield_1", "type": "virtual_good", "name": "Electric shield", "description": "Electric shield", "image_url": "https://cdn3.xsolla.com/img/misc/images/d2d6b1b517e6a7f3765c3bb5a3cfb87d.png", "price": { "amount": "9.99", "amount_without_discount": "9.99", "currency": "USD" }, "virtual_prices": [ {}, {}, {} ], "can_be_bought": true, "promotions": [ {} ], "attributes": [], "is_free": false, "groups": [ {} ], "virtual_item_type": "non_consumable", "limits": { "per_user": {} }, "vp_rewards": [ {}, {} ], "custom_attributes": { "purchased": 0, "attr": "value" } }

Get sellable items list by specified groupClient-side

Request

Gets a sellable items list from the specified group for building a catalog.

Attention

All projects have the limitation to the number of items that you can get in the response. The default and maximum value is 50 items per response. To get more data page by page, use limit and offset fields.

Note

The use of the item catalog API calls is available without authorization, but to get a personalized catalog, you must pass the user JWT in the Authorization header.
Security
XsollaLoginUserJWT
Path
project_idintegerrequired

Project ID. You can find this parameter in your Publisher Account next to the name of the project.

Example: 59080
external_idstringrequired

Group external ID.

Default "armour"
Query
limitinteger>= 1

Limit for the number of elements on the page.

Example: limit=50
offsetinteger>= 0

Number of the element from which the list is generated (the count starts from 0).

Example: offset=0
localestring

Response language. Two-letter lowercase language code per ISO 639-1.

Default "en"
additional_fields[]Array of strings

The list of additional fields. These fields will be in the response if you send them in your request.

Items Enum"media_list""order""long_description""custom_attributes""item_order_in_group"
countrystring

Two-letter uppercase country code per ISO 3166-1 alpha-2. Check the documentation for detailed information about countries supported by Xsolla and the process of determining the country.

Example: country=US
promo_codestring[ 1 .. 128 ] characters

Unique case sensitive code. Contains letters and numbers.

Example: promo_code=WINTER2021
show_inactive_time_limited_itemsinteger

Shows time-limited items that are not available to the user. The validity period of such items has not started or has already expired.

Default 0
Example: show_inactive_time_limited_items=1
curl -i -X GET \
  'https://xsolla.redocly.app/_mock/api/shop-builder/v2/project/59080/items/group/{external_id}?limit=50&offset=0&locale=en&additional_fields%5B%5D=media_list&country=US&promo_code=WINTER2021&show_inactive_time_limited_items=1' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>'

Responses

The list of sellable items from the specified group was successfully received.

Bodyapplication/json
has_moreboolean(Pagination_has-more)

Used as an indicator that there are more pages.

Example: true
itemsArray of objects
Example: [{"item_id":259774,"sku":"com.xsolla.electric_shield_1","type":"virtual_good","name":"Electric shield","description":"Electric shield","image_url":"https://cdn3.xsolla.com/img/misc/images/d2d6b1b517e6a7f3765c3bb5a3cfb87d.png","price":{"amount":"9.99","amount_without_discount":"9.99","currency":"USD"},"virtual_prices":[{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/e2e9ce8b00eb0190c161c4258b899101.png","item_id":259765,"sku":"com.xsolla.gold_1","name":"Gold","type":"virtual_currency","amount":10,"amount_without_discount":10,"calculated_price":{"amount":"10.00","amount_without_discount":"10.00"},"is_default":true},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/015e4f4ea4deb1e2c92d5c21a4d58309.png","item_id":259766,"sku":"com.xsolla.silver_1","name":"Silver","type":"virtual_currency","amount":20,"amount_without_discount":20,"calculated_price":{"amount":"20.00","amount_without_discount":"20.00"},"is_default":false},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/b0beedd5763b612bd3a5631e6cb1d1ff.png","item_id":259767,"sku":"com.xsolla.bronze_1","name":"Bronze","type":"virtual_currency","amount":200,"amount_without_discount":200,"calculated_price":{"amount":"200.00","amount_without_discount":"200.00"},"is_default":false}],"can_be_bought":true,"promotions":[{"name":"Bonus promotion","date_start":"2020-04-15T16:16:00+03:00","date_end":"2026-04-15T16:16:00+03:00","discount":{"percent":"50.00"},"bonus":[{"quantity":1,"name":"Xsolla Minigun","image_url":"https://cdn.xsolla.net/img/misc/images/2fc5c491a47413a8e8000447889093c2.png","sku":"com.xsolla.minigun_1","type":"virtual_good"}]}],"attributes":[],"is_free":false,"groups":[{"external_id":"armour","name":"Armour"}],"virtual_item_type":"non_consumable","limits":{"per_user":{"total":5,"available":3,"recurrent_schedule":{"interval_type":"weekly","reset_next_date":1746057600},"limit_exceeded_visibility":"show"}},"vp_rewards":[{"item_id":175232,"sku":"com.xsolla.value_point_1","amount":130,"name":"Value point","image_url":"https://cdn3.xsolla.com/img/misc/images/54c0cf9d345817cdacfdde198db178e0.jpg"},{"item_id":186321,"sku":"clan_value_point_sku_1","amount":50,"name":"Clan Reward VP 1","image_url":"https://cdn3.xsolla.com/img/misc/images/54c0cf9d345817cdacfdde198db178e0.jpg","is_clan":true}]},{"item_id":259775,"sku":"com.xsolla.royal_shield_1","type":"virtual_good","name":"Royal shield","description":"Royal shield","image_url":"https://cdn3.xsolla.com/img/misc/images/ed417975312a52efeeab8b039ff25cb1.png","price":{"amount":"19.99","amount_without_discount":"19.99","currency":"USD"},"virtual_prices":[{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/e2e9ce8b00eb0190c161c4258b899101.png","item_id":259765,"sku":"com.xsolla.gold_2","name":"Gold","type":"virtual_currency","amount":20,"amount_without_discount":20,"calculated_price":{"amount":"20.00","amount_without_discount":"20.00"},"is_default":true},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/015e4f4ea4deb1e2c92d5c21a4d58309.png","item_id":259766,"sku":"com.xsolla.silver_2","name":"Silver","type":"virtual_currency","amount":40,"amount_without_discount":40,"calculated_price":{"amount":"40.00","amount_without_discount":"40.00"},"is_default":false},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/b0beedd5763b612bd3a5631e6cb1d1ff.png","item_id":259767,"sku":"com.xsolla.bronze_2","name":"Bronze","type":"virtual_currency","amount":400,"amount_without_discount":400,"calculated_price":{"amount":"400.00","amount_without_discount":"400.00"},"is_default":false}],"can_be_bought":true,"promotions":[],"attributes":[],"is_free":false,"groups":[{"external_id":"armour","name":"Armour"}],"virtual_item_type":"non_consumable","vp_rewards":[]},{"item_id":259776,"sku":"com.xsolla.ancient_helmet_1","type":"virtual_good","name":"Ancient helmet","description":"Ancient helmet","image_url":"https://cdn3.xsolla.com/img/misc/images/e70e16d9626f435e519fc8e1cc1e7176.png","price":{"amount":"1.99","amount_without_discount":"1.99","currency":"USD"},"virtual_prices":[{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/e2e9ce8b00eb0190c161c4258b899101.png","item_id":259765,"sku":"com.xsolla.gold_3","name":"Gold","type":"virtual_currency","amount":2,"amount_without_discount":2,"calculated_price":{"amount":"2.00","amount_without_discount":"2.00"},"is_default":true},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/015e4f4ea4deb1e2c92d5c21a4d58309.png","item_id":259766,"sku":"com.xsolla.silver_3","name":"Silver","type":"virtual_currency","amount":4,"amount_without_discount":4,"calculated_price":{"amount":"4.00","amount_without_discount":"4.00"},"is_default":false},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/b0beedd5763b612bd3a5631e6cb1d1ff.png","item_id":259767,"sku":"com.xsolla.bronze_3","name":"Bronze","type":"virtual_currency","amount":40,"amount_without_discount":40,"calculated_price":{"amount":"40.00","amount_without_discount":"40.00"},"is_default":false}],"can_be_bought":true,"promotions":[{"name":"Bonus promotion","date_start":"2020-04-15T16:16:00+03:00","date_end":"2026-04-15T16:16:00+03:00","discount":{"percent":"50.00"},"bonus":[{"quantity":1,"name":"Xsolla Minigun","image_url":"https://cdn.xsolla.net/img/misc/images/2fc5c491a47413a8e8000447889093c2.png","sku":"com.xsolla.minigun_1","type":"virtual_good"}]}],"attributes":[],"is_free":false,"groups":[{"external_id":"armour","name":"Armour"}],"virtual_item_type":"non_consumable","vp_rewards":[]},{"item_id":259777,"sku":"com.xsolla.wooden_helmet_1","type":"virtual_good","name":"Wooden helmet","description":"Wooden helmet","image_url":"https://cdn3.xsolla.com/img/misc/images/40d2812e52ad9d988ac20fc842fc66f0.png","price":{"amount":"0.99","amount_without_discount":"0.99","currency":"USD"},"virtual_prices":[{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/e2e9ce8b00eb0190c161c4258b899101.png","item_id":259765,"sku":"com.xsolla.gold_4","name":"Gold","type":"virtual_currency","amount":1,"amount_without_discount":1,"calculated_price":{"amount":"1.00","amount_without_discount":"1.00"},"is_default":true},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/015e4f4ea4deb1e2c92d5c21a4d58309.png","item_id":259766,"sku":"com.xsolla.silver_4","name":"Silver","type":"virtual_currency","amount":2,"amount_without_discount":2,"calculated_price":{"amount":"2.00","amount_without_discount":"2.00"},"is_default":false},{"description":null,"image_url":"https://cdn3.xsolla.com/img/misc/images/b0beedd5763b612bd3a5631e6cb1d1ff.png","item_id":259767,"sku":"com.xsolla.bronze_4","name":"Bronze","type":"virtual_currency","amount":20,"amount_without_discount":20,"calculated_price":{"amount":"20.00","amount_without_discount":"20.00"},"is_default":false}],"can_be_bought":true,"promotions":[],"attributes":[],"is_free":false,"groups":[{"external_id":"armour","name":"Armour"}],"virtual_item_type":"non_consumable","vp_rewards":[]}]
Response
application/json
{ "has_more": true, "items": [ {}, {}, {}, {} ] }
Operations
Operations
Operations
Operations
Operations

Coupons

This API allows to you to manage coupons.

Operations

Promo codes

This API allows to manage promo codes.

Operations

Unique catalog offers

This API allows to you to manage unique catalog offers.

Operations

Discounts

This API allows to you to manage discount promotions.

Operations

Bonuses

This API allows to manage bonus promotions.

Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations